#pragma once

//#include "MemoryArray.h"
#include "StringBuffer.h"

class CDialogMain
{
protected:
	HWND _hwnd;
	TCHAR* _resourceName;
	INT_PTR static CALLBACK DlgProcCommon(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
	CStringBuffer _settingPath;
	CStringBuffer _exePath;
	bool _unicodeMode;

public:
	CDialogMain(void);
	virtual ~CDialogMain(void);

	void SetUnicodeMode(bool bFlag);
	void SetSettingPath(LPCTSTR path);
	void SetExePath(LPCTSTR path);
	int DoModal();
	int RegistExt(LPCTSTR sExt, bool bDefProg);
	int UnregistExt(LPCTSTR sExt);

protected:
	DWORD LoadSetting();
protected:
	INT_PTR OnDlgProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam, LPARAM lParam);
	INT_PTR OnClose();
	void OnRegistClick();
	void OnUnregistClick();
	void OnVersionClick();
	void OnTypeListChanged();
};
