// sakuext2.cpp : AvP[ṼGg |Cg`܂B
//

#include "stdafx.h"
#include "sakuext2.h"

#include "DialogMain.h"
#include "StringBuffer.h"
#include "PathUtility.h"

//#define MAX_LOADSTRING 100

// ̃R[h W[Ɋ܂܂֐̐錾]܂:
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

	CStringBuffer sAppDataFolder = CPathUtility::GetSpecialFolder(CSIDL_APPDATA);
	CStringBuffer sModuleFolder = CPathUtility::GetParentFolder(CPathUtility::GetModulePath());

	CStringBuffer sIniFileName = DEFINE_SETTING_FILE_NAME_UNICODE;
	CStringBuffer sExePath = CPathUtility::Append(sModuleFolder, DEFINE_EXE_FILE_NAME_UNICODE);
	bool bUnicodeMode = true;
	if(!PathFileExists(sExePath))
	{
		bUnicodeMode = false;
		sIniFileName = DEFINE_SETTING_FILE_NAME_ASCII;
		sExePath = CPathUtility::Append(sModuleFolder, DEFINE_EXE_FILE_NAME_ASCII);
		if(!PathFileExists(sExePath))
		{
			MessageBox(NULL, _TEXT("TNGfB^܂B"), _TEXT("G["), MB_OK);
			return -2;
		}
	}

	CStringBuffer sIniPathAppData = CPathUtility::Append(CPathUtility::Append(sAppDataFolder, DEFINE_APPDATA_FOLDER_NAME), sIniFileName);
	CStringBuffer sIniPathModule = CPathUtility::Append(sModuleFolder, sIniFileName);
	CStringBuffer sIniPath = sIniPathAppData;
	if(!PathFileExists(sIniPath))
	{
		sIniPath = sIniPathModule;
		if(!PathFileExists(sIniPath))
		{
			if(MessageBox(NULL, _TEXT("ݒt@C܂BTNGfB^N܂H"), _TEXT("mF"), MB_OKCANCEL) != IDOK)
			{
				return 1;
			}
			ShellExecute(NULL, NULL, sExePath, NULL, _TEXT(""), SW_SHOW);
			time_t startTime = time(NULL);
			while(startTime + 10 >= time(NULL))
			{
				if(PathFileExists(sIniPathAppData) || PathFileExists(sIniPathModule))
				{
					break;
				}
				Sleep(1);
			}
			sIniPath = sIniPathAppData;
			if(!PathFileExists(sIniPath))
			{
				sIniPath = sIniPathModule;
				if(!PathFileExists(sIniPath))
				{
					MessageBox(NULL, _TEXT("10bҋ@܂Aݒt@C܂łB"), _TEXT("G["), MB_OK);
					return -3;
				}
			}
		}
	}

	CDialogMain dialog;
	dialog.SetUnicodeMode(bUnicodeMode);
	dialog.SetSettingPath(sIniPath);
	dialog.SetExePath(sExePath);
	dialog.DoModal();

	return 0;
}



// o[W{bNX̃bZ[W nhłB
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
